typedef volatile int spinlock_t;

#define swap(adr,reg)                           \
        ({ char _ret;                           \
           asm volatile ("xchgb %1,%0"          \
                : "=q" (_ret), "=m" (*(adr))    \
                : "m"  (*(adr)), "0"  (reg));   \
           _ret;                                \
        })

#define spin_lock_init(SPINLOCK) ((SPINLOCK) = 0)
#define spin_unlock(SPINLOCK)    ((SPINLOCK) = 0)
#define spin_lock(SPINLOCK)                     \
        do {                                    \
          if (swap((&(SPINLOCK)),1)==0) break;  \
          while ((SPINLOCK) != 0) continue;     \
        } while (1)

/***********************************************************\
*** Alternative using the pthread spinlock implementation ***
\***********************************************************/
/*
#include <pthread.h>

typedef pthread_spinlock_t spinlock_t;

#define spin_lock_init(SPINLOCK)  pthread_spin_init(&(SPINLOCK), PTHREAD_PROCESS_SHARED)
#define spin_unlock(SPINLOCK)     pthread_spin_unlock(&(SPINLOCK))
#define spin_lock(SPINLOCK)       pthread_spin_lock(&(SPINLOCK))
*/
